/****************************************************************************

    PROGRAM: Generic.c

    PURPOSE: Generic template for Windows applications

    FUNCTIONS:

	WinMain() - calls initialization function, processes message loop
	InitApplication() - initializes window data and registers window
	InitInstance() - saves instance handle and creates main window
	MainWndProc() - processes messages
	About() - processes messages for "About" dialog box

    COMMENTS:

        Windows can have several copies of your application running at the
        same time.  The variable hInst keeps track of which instance this
        application is so that processing will be to the correct window.

****************************************************************************/

#include "windows.h"		    /* required for all Windows applications */
#include "generic.h"		    /* specific to this program		     */
#include "paint.h"

HANDLE hInst;			    /* current instance			     */

#define		NUM_AE		79

char *AE[] ={
"1:@echo off",
"2:echo Load Mouse",
"3:lh c:\\windows\\mouse.com /Y",
"4:",
"5:c:\\dos\\dos\\ynct /c:yn /t:10 /d:y \"Load Network?\"",
"6:if errorlevel 1 goto NoNet",
"7:lh c:\\dos\\lantasti\\aex",
"8:lh c:\\dos\\lantasti\\ailanbio",
"lh c:\\dos\\lantasti\\REDIR BEAST LOGINS=2",
"lh c:\\dos\\dos\\share",
"c:\\dos\\lantasti\\NET LOGIN/WAIT \\\\COGSWORTH DAVE",
"c:\\dos\\lantasti\\NET USE N: \\\\COGSWORTH\\C-DRIVE",
"c:\\dos\\lantasti\\NET USE O: \\\\COGSWORTH\\D-DRIVE",
"c:\\dos\\lantasti\\NET USE P: \\\\COGSWORTH\\E-DRIVE",
"c:\\dos\\lantasti\\NET USE LPT2 \\\\COGSWORTH\\@PRINTER",
":NoNet",
"",
"echo Load DosKey, SmartDrv, & CD-ROM",
"lh c:\\device\\cdrom\\MSCDEX.EXE /D:CD-ROM /M:10 /V",
"lh c:\\device\\dgis\\dgis",
"C:\\WINDOWS\\SMARTDRV.EXE 4096 2048 A+ B+",
"lh c:\\dos\\dos\\doskey /insert",
"",
"c:\\dos\\dos\\ynct /c:yn /t:10 /d:n \"Load Fax?\"",
"if errorlevel 1 goto NoFax",
"lh C:\\APPS\\DOSAPPS\\FAX\\CASMGR.EXE C:\\APPS\\DOSAPPS\\FAX\\CASMGR.CFG",
"rem C:\\APPS\\DOSAPPS\\FAX\\FAXPOP.EXE",
":NoFax",
"",
"echo Set up path",
"path c:\\;c:\\dos\\dos;c:\\dos\\pcmag;C:\\APPS\\DOSAPPS\\FAX",
"prompt $p$g",
"numoff",
"",
"echo Set up SUBST drives",
"subst z: c:\\tools\\c700",
"subst y: c:\\tools\\windev",
"subst x: c:\\tools\\masm",
"subst w: c:\\tools\\brief\\bin",
"subst v: c:\\dos",
"subst u: c:\\tools",
"subst t: c:\\tools\\winddk",
"",
"echo Set up environment",
"path c:\\windows;v:\\dos;v:\\nu;v:\\pcmag;c:\\;w:\\;x:\\soft-ice;u:\\bin;u:\\common;z:\\bin;y:\\bin;x:\\bin;t:\\bin;C:\\APPS\\DOSAPPS\\FAX",
"",
"set bpath=c:\\tools\\brief\\macros",
"set bhelp=c:\\tools\\brief\\help",
"set bfile=c:\\tools\\brief\\misc\\state.rst",
"set bbackup=c:\\tools\\brief\\backup",
"set bccpp=\"!bcc -c %%s.cpp\"",
"set bcc=\"!cl -c %%s.c\"",
"set bcasm=\"!masm %%s.asm\\;\"",
"set bpackages=h-c,hpp-cpp,cpp,c,asm:t",
"set bflags=-bi30k1Mu60z -mDNT -mrestore -Dega -D101key",
"",
"rem set cflags=-a1 -br -J -mm -2 -W -DZTC -DmemM -DHBERROR -DCPP",
"rem set cl=-AM -G2sw -J -W3 -Zp -DMSC -DmemM -nologo",
"rem set masm=-Ml -p -z -w2 -Zi -DmemM",
"rem set link=/MAP /ALIGN:16",
"SET LIB=Z:\\LIB;Z:\\MFC\\LIB;Y:\\LIB;C:\\SRC\\LIB;",
"SET INCLUDE=Z:\\INCLUDE;Z:\\MFC\\INCLUDE;Y:\\INCLUDE;C:\\SRC\\INCLUDE;",
"SET HELPFILES=Z:\\HELP;C:\\TOOLS\\HELP\\*.HLP",
"SET INIT=C:\\dos\\ini",
"SET HOME=C:\\dos\\ini",
"SET PICTOR=c:\\apps\\dosapps\\grasp",
"SET GRASP=c:\\apps\\dosapps\\grasp",
"",
"set msdos=yes",
"SET NU=C:\\DOS\\NU",
"set CDPATH=C:\\apps\\dosapps\\BKSHLF;E:\\SOFTWARE;E:\\BOOK",
"SET pcplus=c:\\apps\\dosapps\\pcplus",
"",
"echo Set up RAM disk",
"md d:\\temp",
"set TEMP=d:\\temp",
"set TMP=d:\\temp",
"",
"mode com1 9600,n,8,1"
};


/****************************************************************************

    FUNCTION: WinMain(HANDLE, HANDLE, LPSTR, int)

    PURPOSE: calls initialization function, processes message loop

    COMMENTS:

        Windows recognizes this function by name as the initial entry point 
        for the program.  This function calls the application initialization 
        routine, if no other instance of the program is running, and always 
        calls the instance initialization routine.  It then executes a message 
        retrieval and dispatch loop that is the top-level control structure 
        for the remainder of execution.  The loop is terminated when a WM_QUIT 
        message is received, at which time this function exits the application 
        instance by returning the value passed by PostQuitMessage(). 

        If this function must abort before entering the message loop, it 
        returns the conventional value NULL.  

****************************************************************************/

int PASCAL WinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow)
HANDLE hInstance;			     /* current instance	     */
HANDLE hPrevInstance;			     /* previous instance	     */
LPSTR lpCmdLine;			     /* command line		     */
int nCmdShow;				     /* show-window type (open/icon) */
{
    MSG msg;				     /* message			     */

    if (!hPrevInstance)			 /* Other instances of app running? */
	if (!InitApplication(hInstance)) /* Initialize shared things */
	    return (FALSE);		 /* Exits if unable to initialize     */

    /* Perform initializations that apply to a specific instance */

    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);

    /* Acquire and dispatch messages until a WM_QUIT message is received. */

    while (GetMessage(&msg,	   /* message structure			     */
	    NULL,		   /* handle of window receiving the message */
	    NULL,		   /* lowest message to examine		     */
	    NULL))		   /* highest message to examine	     */
	{
	TranslateMessage(&msg);	   /* Translates virtual key codes	     */
	DispatchMessage(&msg);	   /* Dispatches message to window	     */
    }
    return (msg.wParam);	   /* Returns the value from PostQuitMessage */
}


/****************************************************************************

    FUNCTION: InitApplication(HANDLE)

    PURPOSE: Initializes window data and registers window class

    COMMENTS:

        This function is called at initialization time only if no other 
        instances of the application are running.  This function performs 
        initialization tasks that can be done once for any number of running 
        instances.  

        In this case, we initialize a window class by filling out a data 
        structure of type WNDCLASS and calling the Windows RegisterClass() 
        function.  Since all instances of this application use the same window 
        class, we only need to do this when the first instance is initialized.  


****************************************************************************/

BOOL InitApplication(hInstance)
HANDLE hInstance;			       /* current instance	     */
{
    WNDCLASS  wc;

    /* Fill in window class structure with parameters that describe the       */
    /* main window.                                                           */

    wc.style = NULL;                    /* Class style(s).                    */
    wc.lpfnWndProc = MainWndProc;       /* Function to retrieve messages for  */
                                        /* windows of this class.             */
    wc.cbClsExtra = 0;                  /* No per-class extra data.           */
    wc.cbWndExtra = 0;                  /* No per-window extra data.          */
    wc.hInstance = hInstance;           /* Application that owns the class.   */
    wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = CreateHatchBrush (HS_BDIAGONAL, RGB (255,0,0)); //GetStockObject(WHITE_BRUSH); 
    wc.lpszMenuName =  "GenericMenu";   /* Name of menu resource in .RC file. */
    wc.lpszClassName = "GenericWClass"; /* Name used in call to CreateWindow. */

    /* Register the window class and return success/failure code. */

    return (RegisterClass(&wc));

}


/****************************************************************************

    FUNCTION:  InitInstance(HANDLE, int)

    PURPOSE:  Saves instance handle and creates main window

    COMMENTS:

        This function is called at initialization time for every instance of 
        this application.  This function performs initialization tasks that 
        cannot be shared by multiple instances.  

        In this case, we save the instance handle in a static variable and 
        create and display the main program window.  
        
****************************************************************************/

BOOL InitInstance(hInstance, nCmdShow)
    HANDLE          hInstance;          /* Current instance identifier.       */
    int             nCmdShow;           /* Param for first ShowWindow() call. */
{
    HWND            hWnd;               /* Main window handle.                */

    /* Save the instance handle in static variable, which will be used in  */
    /* many subsequence calls from this application to Windows.            */

    hInst = hInstance;

    /* Create a main window for this application instance.  */

    hWnd = CreateWindow(
        "GenericWClass",                /* See RegisterClass() call.          */
        "Generic Sample Application",   /* Text for window title bar.         */
        WS_OVERLAPPEDWINDOW,            /* Window style.                      */
        CW_USEDEFAULT,                  /* Default horizontal position.       */
        CW_USEDEFAULT,                  /* Default vertical position.         */
        CW_USEDEFAULT,                  /* Default width.                     */
        CW_USEDEFAULT,                  /* Default height.                    */
        NULL,                           /* Overlapped windows have no parent. */
        NULL,                           /* Use the window class menu.         */
        hInstance,                      /* This instance owns this window.    */
        NULL                            /* Pointer not needed.                */
    );

    /* If window could not be created, return "failure" */

    if (!hWnd)
        return (FALSE);

    /* Make the window visible; update its client area; and return "success" */

    ShowWindow(hWnd, nCmdShow);  /* Show the window                        */
    UpdateWindow(hWnd);          /* Sends WM_PAINT message                 */
    return (TRUE);               /* Returns the value from PostQuitMessage */

}

/****************************************************************************

    FUNCTION: MainWndProc(HWND, unsigned, WORD, LONG)

    PURPOSE:  Processes messages

    MESSAGES:

	WM_COMMAND    - application menu (About dialog box)
	WM_DESTROY    - destroy window

    COMMENTS:

	To process the IDM_ABOUT message, call MakeProcInstance() to get the
	current instance address of the About() function.  Then call Dialog
	box which will create the box according to the information in your
	generic.rc file and turn control over to the About() function.	When
	it returns, free the intance address.

****************************************************************************/




long FAR PASCAL MainWndProc(hWnd, message, wParam, lParam)
HWND hWnd;				  /* window handle		     */
unsigned message;			  /* type of message		     */
WORD wParam;				  /* additional information	     */
LONG lParam;				  /* additional information	     */
{
    FARPROC lpProcAbout;		  /* pointer to the "About" function */
		HDC			hDc;							/* device context for painting */
		RECT		Rect;							/* rect for drawing text */
		int			iNum;
		TEXTMETRIC tm, tm2;
		PAINTBLT sPb;

    switch (message) {
	case WM_COMMAND:	   /* message: command from application menu */
	    if (wParam == IDM_ABOUT) {
		lpProcAbout = MakeProcInstance(About, hInst);

		DialogBox(hInst,		 /* current instance	     */
		    "AboutBox",			 /* resource to use	     */
		    hWnd,			 /* parent handle	     */
		    lpProcAbout);		 /* About() instance address */

		FreeProcInstance(lpProcAbout);
		break;
	    }
	    else			    /* Lets Windows process it	     */
		return (DefWindowProc(hWnd, message, wParam, lParam));

	case WM_DESTROY:		  /* message: window being destroyed */
	    PostQuitMessage(0);
	    break;



	case WM_ERASEBKGND :
		return (0);					// 0 means it is NOT erased!!!

	case WM_PAINT:				/* message: paint the window */
			hDc = PaintBegin (hWnd, &sPb);

			PaintSetViewOrg (&sPb, 8, 16);

			SetMapMode (hDc, MM_HIENGLISH);

			SetMapMode (PaintGetDc (&sPb), MM_HIENGLISH);
			GetTextMetrics (PaintGetDc (&sPb), &tm);

			for (iNum=0; iNum<NUM_AE/2-2; iNum++)
				{
				TextOut (hDc, 0, - iNum*tm.tmHeight, AE[iNum], strlen (AE[iNum]));
				TextOut (hDc, 40*tm.tmAveCharWidth, - iNum*tm.tmHeight, AE[iNum+NUM_AE/2], strlen (AE[iNum+NUM_AE/2]));
				}

			PaintEnd (&sPb);
			break;



	default:			  /* Passes it on if unproccessed    */
	    return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return (NULL);
}


/****************************************************************************

    FUNCTION: About(HWND, unsigned, WORD, LONG)

    PURPOSE:  Processes messages for "About" dialog box

    MESSAGES:

	WM_INITDIALOG - initialize dialog box
	WM_COMMAND    - Input received

    COMMENTS:

	No initialization is needed for this particular dialog box, but TRUE
	must be returned to Windows.

	Wait for user to click on "Ok" button, then close the dialog box.

****************************************************************************/

BOOL FAR PASCAL About(hDlg, message, wParam, lParam)
HWND hDlg;                                /* window handle of the dialog box */
unsigned message;                         /* type of message                 */
WORD wParam;                              /* message-specific information    */
LONG lParam;
{
    switch (message) {
	case WM_INITDIALOG:		   /* message: initialize dialog box */
	    return (TRUE);

	case WM_COMMAND:		      /* message: received a command */
	    if (wParam == IDOK                /* "OK" box selected?	     */
                || wParam == IDCANCEL) {      /* System menu close command? */
		EndDialog(hDlg, TRUE);	      /* Exits the dialog box	     */
		return (TRUE);
	    }
	    break;
    }
    return (FALSE);			      /* Didn't process a message    */
}

