
//REGEN_FILEHEADING
//REGEN_FILEHEADING


     /********************************************************************
      *                                                                  *
      *   Source File: BITBLTWI.cpp                                      *
      *   Description: C++ Source file for BITBLTWI application          *
      *   Date:        Fri Jun 18 13:50:58 1993                          *
      *                                                                  *
      ********************************************************************/

#include <owl.h>
#include <edit.h>
#include <listbox.h>
#include <combobox.h>
#include <bchkbox.h>
#include <checkbox.h>
#include <bradio.h>
#include <radiobut.h>
#include <scrollba.h>
#include <dialog.h>
#include <bwcc.h>
#include <dtctl.h>
#include <math.h>
#include "BITBLTID.h"
#include "BITBLTWI.h"
#include "bltwin.hpp"

//REGEN_VARIABLES
//REGEN_VARIABLES


// Define application class derived from  TApplication
class TBITBLTWI : public TApplication
{
public:
  TBITBLTWI(LPSTR AName, HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
    : TApplication(AName, hInstance, hPrevInstance, lpCmdLine, nCmdShow) {};
    virtual void InitMainWindow();
    //REGEN_APPCLASS
    //REGEN_APPCLASS
};

// Declare TMainWindow, a TWindow descendant
class TMainWindow : public TWindow
{
	WORD *wData;
	float fGain;
	float fStdDev;
	float fStdDevVar;
	int iExpMean,iExpMeanVar;

public:
	TMainWindow(PTWindowsObject AParent, LPSTR ATitle);
	~TMainWindow();

	virtual void WMDestroy(RTMessage Msg) = [WM_FIRST + WM_DESTROY];
	virtual void WMTimer(RTMessage Msg) = [WM_FIRST + WM_TIMER];
	virtual void	Paint(HDC PaintDC,PAINTSTRUCT _FAR & PaintInfo);
	virtual void GO(RTMessage Msg) = [CM_FIRST + IDM_GO];
	virtual void END(RTMessage Msg) = [CM_FIRST + IDM_END];
   //REGEN_MAINCLASS
   //REGEN_MAINCLASS

};


/****************************************************
 * TMainWindow implementations: 
 ****************************************************/

// Define TMainWindow, a TWindow constructor
TMainWindow::TMainWindow(PTWindowsObject AParent, LPSTR ATitle)
						 : TWindow(AParent, ATitle)
{
   AssignMenu("BItBltWi");
   //REGEN_MAINCONSTRUCT
   wData = (WORD*)new(WORD[2048]);
   fGain = 245.;
	fStdDev = 30.;
	fStdDevVar = 5.0;
	iExpMean = 512;
	iExpMeanVar = 10;

	if(wData)
	{
		int i;
        float fExp;
		for(i = 0; i < 2048; i++)
		{
			fExp = (float)(i - iExpMean)/fStdDev;
			fExp = exp(-fExp * fExp);
			wData[i] = (WORD)(fGain * fExp);
		}
	}
   //REGEN_MAINCONSTRUCT

}

// Define TMainWindow destructor
TMainWindow::~TMainWindow()
{
   //REGEN_MAINDESTRUCT
	delete [] wData;
   //REGEN_MAINDESTRUCT

}

void TMainWindow::WMDestroy(RTMessage Msg)
{
	KillTimer(HWindow,1);
	TWindow::WMDestroy(Msg);

}



void TMainWindow::WMTimer(RTMessage)
{
	int i;
	float fExp;

	fStdDev += fStdDevVar;
	if(fStdDev > 80)
		fStdDevVar = -fStdDevVar;
	else if(fStdDev < 30)
		fStdDevVar = fabs(fStdDevVar);

	iExpMean += iExpMeanVar;
	if(iExpMean > 1024)
		iExpMeanVar = -iExpMeanVar;
	else if(iExpMean < 512)
		iExpMeanVar = abs(iExpMeanVar);

	for(i = 0; i < 2048; i++)
	{
		fExp = (float)(i - iExpMean)/fStdDev;
		fExp = exp(-fExp * fExp);
		wData[i] = (WORD)(fGain * fExp);
	}

	InvalidateRect(HWindow,NULL,TRUE);

}

void	TMainWindow::Paint(HDC PaintDC,PAINTSTRUCT _FAR &)
{
	RECT rClient;
	int i;

	GetClientRect(HWindow,&rClient);
//	Rectangle(PaintDC,0,0,rClient.right,rClient.bottom);
	SetMapMode(PaintDC,MM_ANISOTROPIC);
	SetWindowExt(PaintDC,2048,-255);
	SetViewportExt(PaintDC,rClient.right,rClient.bottom);
	SetViewportOrg(PaintDC,0,rClient.bottom);
	MoveTo(PaintDC,0,wData[0]);
	for(i = 1; i < 2048; i++)
		LineTo(PaintDC,i,wData[i]);

}

void TMainWindow::GO(RTMessage)
{
   //REGEN_EXEC
	SetTimer(HWindow,1,100,NULL);
   //REGEN_EXEC
}

void TMainWindow::END(RTMessage)
{
   //REGEN_EXEC
   PostQuitMessage(0);
   //REGEN_EXEC
}


/***************************************************
 * TBITBLTWIApp method implementations:
 ***************************************************/

// Construct the TBITBLTWI's MainWindow of type TMainWindow
void TBITBLTWI::InitMainWindow()
{
   MainWindow = new TMainWindow(NULL, Name);
   //REGEN_MAINCREATE
   //REGEN_MAINCREATE
}

// Main program
int PASCAL WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,
                   int nCmdShow)
{
   HINSTANCE hBorLibrary;

   hBorLibrary = LoadLibrary("bwcc.dll");

   if((UINT)hBorLibrary <= 32)
      MessageBox(NULL, "Unable to load Borland Controls", "System Error", MB_OK | MB_ICONHAND);

   //REGEN_INIT
   //REGEN_INIT

   TBITBLTWI BITBLTWI ("BitBlt Paint Window", hInstance, hPrevInstance,
      lpCmdLine, nCmdShow);

   BITBLTWI.Run();

   if((UINT)hBorLibrary > 32)
      FreeLibrary(hBorLibrary);

   //REGEN_CLEANUP
   //REGEN_CLEANUP

   return BITBLTWI.Status;
}

//REGEN_CUSTOMCODE
//REGEN_CUSTOMCODE
